/* 
* Read accelerators on MPC5125 TWR and trigger voice commands
*/


#include <linux/input.h>
#include <stdlib.h>
#include <stdio.h>
#include <time.h>
#include <signal.h>
#include <unistd.h>
#include <sys/time.h>
#include <sys/types.h>
#include <fcntl.h>
#include <dirent.h>
#include <errno.h>

#define DIR_PREFIX	"/dev/input"
#define MMA7660NAME	"mma7660abs"

int main (int argc , char *argv[]) {
	int 		fd;
	char 		evname[64];
	int 		bytes_read;
	struct input_event event;
	struct timeval 	tv;
	int 		retval;
	fd_set 		rfds;
        DIR             *dp;
        struct dirent   *ep;
	char 		filename[64];
	char 		buf[256];
	int		last_command = 0;

	int 		abs_x,abs_y,abs_z;
	int		tilt=0;

	int 		ev_found = 0;

	printf ("gsensor input device absolute value reading program \n");

	dp = opendir (DIR_PREFIX);

	if (dp != NULL) {
		while (ep = readdir(dp)) {
			if ((ep->d_type == DT_CHR) && (memcmp(ep->d_name,"event",5) == 0)) {
				sprintf(filename,"%s/%s",DIR_PREFIX,ep->d_name);
				printf("Check %s ",filename);
				fd = open(filename,O_NONBLOCK);

				if (ioctl(fd, EVIOCGNAME(sizeof evname), evname) >= 0) {
					printf ("event device name is %s\n",evname);
					if (strcmp(evname,MMA7660NAME) == 0) {
						printf("found \n");
						ev_found = 1;
						break;
					}
				} else {
					printf (" is not a event device file \n");
				}
			}
                }
                (void) closedir(dp);
        } else {
                printf("Could not open input device directory %s\n",DIR_PREFIX);
                return (-1);
        }


	if (ev_found = 0) {
		printf ("Could not found event device file for retrieve MMA7660 data\n");
		return (-1);
	}


	FD_ZERO(&rfds);
	FD_SET(fd, &rfds);

	while (1) {
		retval = select(FD_SETSIZE, &rfds, NULL, NULL, NULL);

		if (retval == -1) {
			perror("select()");
			exit (-1);
		} else if (retval) {
			while (bytes_read = read(fd, &event, sizeof(event))) {

				if (bytes_read == -1) {
					break;
				}
				if(bytes_read != sizeof(event)) {
					printf("byte read %d\n",bytes_read);
					break;
				}
				if (event.type == EV_ABS) {
					switch (event.code) {
						case ABS_X:
							abs_x = event.value;
							break;
						case ABS_Y:
							abs_y = event.value;
							break;
						case ABS_Z:
							abs_z = event.value;
							break;
						case ABS_MISC:
							tilt = event.value;
					}
				} else if (event.type == EV_SYN) {

					printf ("event %d.%06d X:%d Y:%d Z:%d Tilt:0x%x\r",event.time.tv_sec,event.time.tv_usec,abs_x,abs_y,abs_z,tilt);
					fflush(0);

		

					//sound play
					if(abs_x > -3 && abs_x < 3 && abs_y < 3 && abs_y > -3 && abs_z < -18 && last_command != 0)
					{
						sprintf(buf, "/usr/bin/aplay sounds/bass.wav");
						system(buf);
						sprintf(buf, "/usr/bin/aplay sounds/center.wav");
               				         system(buf);
						last_command = 0;
					}else if(abs_z > -4 && abs_z < 4 && abs_y < 4 && abs_y > -4 && abs_x < -18 && last_command != 1)
              				{
                     				sprintf(buf, "/usr/bin/aplay sounds/stuck1.wav");
                        			system(buf);
						sprintf(buf, "/usr/bin/aplay sounds/right.wav");
                        			system(buf);
						last_command = 1;
                			}else if(abs_z > -4 && abs_z < 4 && abs_y < 4 && abs_y > -4 && abs_x > 18 && last_command != 2)
                			{
                        			sprintf(buf, "/usr/bin/aplay sounds/stuck1.wav");
                        			system(buf);
                        			sprintf(buf, "/usr/bin/aplay sounds/left.wav");
                        			system(buf);
						last_command = 2;
                			}else if(abs_z > -4 && abs_z < 4 && abs_x < 4 && abs_x > -4 && abs_y < -18 && last_command != 3)
                			{
                        			sprintf(buf, "/usr/bin/aplay sounds/stuck1.wav");
                        			system(buf);
                        			sprintf(buf, "/usr/bin/aplay sounds/back.wav");
                        			system(buf);
                        			last_command = 3;
                			}else if(abs_z > -4 && abs_z < 4 && abs_x < 4 && abs_x > -4 && abs_y > 18 && last_command != 4)
                			{
                        			sprintf(buf, "/usr/bin/aplay sounds/stuck1.wav");
                        			system(buf);
                        			sprintf(buf, "/usr/bin/aplay sounds/forward.wav");
                        			system(buf);
                        			last_command = 4;
                			}
				}
			}
		}
	}
}

